#
# Ľṹ `dvhome_forum`
#

CREATE TABLE `dvhome_forum` (
  `id` int(10) NOT NULL auto_increment,
  `post_user` varchar(20) NOT NULL default '',
  `post_time` int(11) NOT NULL default '0',
  `post_ip` varchar(15) NOT NULL default '',
  `face_icon` varchar(20) NOT NULL default '',
  `subject` varchar(202) NOT NULL default '',
  `content` text NOT NULL,
  `content_size` int(11) NOT NULL default '0',
  `upload_file` varchar(50) NOT NULL default '',
  `upload_file_ext` varchar(20) NOT NULL default '',
  `upload_file_name` varchar(255) NOT NULL default '',
  `upload_file_size` int(8) NOT NULL default '0',
  `upload_file_width` tinyint(4) NOT NULL default '0',
  `upload_file_heigh` tinyint(4) NOT NULL default '0',
  `upload_file_hits` int(8) NOT NULL default '0',
  `hits` int(5) NOT NULL default '0',
  `child` int(5) NOT NULL default '0',
  `update_time` int(11) NOT NULL default '0',
  `deleted` int(1) NOT NULL default '0',
  `choose` int(1) NOT NULL default '0',
  `locked` int(1) NOT NULL default '0',
  `top` int(1) NOT NULL default '0',
  `cat_id` int(3) NOT NULL default '0',
  `root_id` int(10) NOT NULL default '0',
  `tab` tinyint(2) NOT NULL default '0',
  `lay_id` varchar(90) NOT NULL default '',
  `mark` tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `root_id` (`root_id`,`lay_id`),
  KEY `tab` (`tab`,`deleted`,`top`,`cat_id`,`update_time`),
  KEY `cat_id` (`cat_id`,`deleted`,`top`,`update_time`),
  KEY `post_time` (`post_time`,`top`),
  KEY `post_name` (`post_user`,`post_time`),
  KEY `update_time` (`update_time`)
) TYPE=MyISAM COMMENT='̳Ϣ';

# --------------------------------------------------------

#
# Ľṹ `dvhome_forum_cat`
#

CREATE TABLE `dvhome_forum_cat` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `description` text NOT NULL,
  `image` varchar(100) NOT NULL default '',
  `root_id` int(10) NOT NULL default '0',
  `published` tinyint(1) NOT NULL default '1',
  `created_time` datetime default NULL,
  `ordering` tinyint(4) NOT NULL default '1',
  `lay_id` varchar(90) NOT NULL default '',
  `tab` tinyint(1) NOT NULL default '0',
  `hits` int(5) NOT NULL default '0',
  `num_articles` int(11) NOT NULL default '0',
  `num_visits` int(11) NOT NULL default '0',
  `num_threads` int(11) NOT NULL default '0',
  `num_records` int(11) NOT NULL default '0',
  `master` varchar(100) NOT NULL default '',
  `sticky` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='̳';

# --------------------------------------------------------

#
# Ľṹ `dvhome_globals`
#

CREATE TABLE `dvhome_globals` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `array_name` varchar(50) NOT NULL default '',
  `key` varchar(100) NOT NULL default '',
  `default_value` text NOT NULL,
  `current_value` text NOT NULL,
  `description` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `key` (`key`)
) TYPE=MyISAM COMMENT='̳һò';

# --------------------------------------------------------

#
# Ľṹ `dvhome_mediacode`
#

CREATE TABLE `dvhome_mediacode` (
  `id` int(11) NOT NULL auto_increment,
  `type` varchar(20) NOT NULL default '',
  `code` text NOT NULL,
  `memo` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `type` (`type`)
) TYPE=MyISAM COMMENT='ʾ';

# --------------------------------------------------------

#
# Ľṹ `dvhome_message`
#

CREATE TABLE `dvhome_message` (
  `id` int(10) NOT NULL auto_increment,
  `sender` varchar(20) NOT NULL default '',
  `receiver` varchar(20) NOT NULL default '',
  `send_time` int(11) NOT NULL default '0',
  `subject` varchar(200) NOT NULL default '',
  `content` text NOT NULL,
  `del_by_sender` tinyint(1) NOT NULL default '0',
  `del_by_receiver` tinyint(1) NOT NULL default '0',
  `read` tinyint(1) NOT NULL default '0',
  `hide` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `sender` (`sender`),
  KEY `receiver` (`receiver`),
  KEY `send_time` (`send_time`),
  KEY `read` (`read`),
  KEY `hide` (`hide`)
) TYPE=MyISAM COMMENT='ûԱ';

# --------------------------------------------------------

#
# Ľṹ `dvhome_modules`
#

CREATE TABLE `dvhome_modules` (
  `id` smallint(6) NOT NULL auto_increment,
  `description` varchar(100) NOT NULL default '',
  `target_dir` varchar(100) NOT NULL default '',
  `display_code` text NOT NULL,
  `hide_to_group` text NOT NULL,
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='ģǼ';

# --------------------------------------------------------

#
# Ľṹ `dvhome_permissions`
#

CREATE TABLE `dvhome_permissions` (
  `effect_area` varchar(20) NOT NULL default '',
  `permission` text NOT NULL,
  `description` text NOT NULL,
  `memo` text NOT NULL
) TYPE=MyISAM COMMENT='ģ֤ͨǼǱģ÷ΧΪȫ/ֲ';

# --------------------------------------------------------

#
# Ľṹ `dvhome_usergroup`
#

CREATE TABLE `dvhome_usergroup` (
  `ugid` int(5) NOT NULL auto_increment,
  `group_name` varchar(40) NOT NULL default '',
  `group_cat` tinyint(1) NOT NULL default '2',
  `group_memo` text NOT NULL,
  `group_permissions` text NOT NULL,
  PRIMARY KEY  (`ugid`),
  UNIQUE KEY `group_name` (`group_name`)
) TYPE=MyISAM COMMENT='û' AUTO_INCREMENT=100 ;

# --------------------------------------------------------

#
# Ľṹ `dvhome_users`
#

CREATE TABLE `dvhome_users` (
  `id` int(10) NOT NULL auto_increment,
  `uuid` varchar(38) NOT NULL default '',
  `name` varchar(20) NOT NULL default '',
  `user_group` varchar(20) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `reg_ip` varchar(15) NOT NULL default '',
  `reg_time` int(12) NOT NULL default '0',
  `city` varchar(20) NOT NULL default '',
  `qq` varchar(12) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `show_email` tinyint(1) NOT NULL default '0',
  `msn` varchar(20) NOT NULL default '',
  `website` varchar(100) NOT NULL default '',
  `sign` text NOT NULL,
  `other_info` text NOT NULL,
  `rank` int(10) NOT NULL default '0',
  `old_rank` int(8) NOT NULL default '0',
  `point` int(8) NOT NULL default '0',
  `num_visit` int(8) NOT NULL default '0',
  `num_article` int(8) NOT NULL default '0',
  `last_visit` int(12) NOT NULL default '0',
  `last_submit` int(12) NOT NULL default '0',
  `last_subject` varchar(255) NOT NULL default '',
  `Uid` varchar(11) NOT NULL default '65534',
  `Gid` varchar(11) NOT NULL default '65534',
  `Dir` varchar(128) NOT NULL default '/home/_ftp/pub/',
  `real_name` varchar(20) NOT NULL default '',
  `phone` varchar(100) NOT NULL default '',
  `address` varchar(200) NOT NULL default '',
  `zipcode` varchar(6) NOT NULL default '',
  `open` tinyint(1) NOT NULL default '0',
  `bookmark` text NOT NULL,
  `face0` varchar(20) NOT NULL default '',
  `face1` varchar(20) NOT NULL default '',
  `face2` varchar(20) NOT NULL default '',
  `face3` varchar(20) NOT NULL default '',
  `new_message` int(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`,`password`),
  KEY `uuid` (`uuid`)
) TYPE=MyISAM COMMENT='û';

